QCPAxisTickerLog Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Functions | Protected Functions
QCPAxisTickerLog Class Reference

Specialized axis ticker suited for logarithmic axes. More...

Inheritance diagram for QCPAxisTickerLog:

## Public Functions
| QCPAxisTickerLog ()
double | logBase () const
int | subTickCount () const
void | setLogBase (double base)
void | setSubTickCount (int subTicks)
Public Functions inherited from QCPAxisTicker
| QCPAxisTicker ()
TickStepStrategy | tickStepStrategy () const
int | tickCount () const
double | tickOrigin () const
void | setTickStepStrategy (TickStepStrategy strategy)
void | setTickCount (int count)
void | setTickOrigin (double origin)
virtual void | generate (const QCPRange &range, const QLocale &locale, QChar formatChar, int precision, QVector< double > &ticks, QVector< double > *subTicks, QVector< QString > *tickLabels)

## Protected Functions
virtual int | getSubTickCount (double tickStep)
virtual QVector< double > | createTickVector (double tickStep, const QCPRange &range)
Protected Functions inherited from QCPAxisTicker
virtual double | getTickStep (const QCPRange &range)
virtual QString | getTickLabel (double tick, const QLocale &locale, QChar formatChar, int precision)
virtual QVector< double > | createSubTickVector (int subTickCount, const QVector< double > &ticks)
virtual QVector< QString > | createLabelVector (const QVector< double > &ticks, const QLocale &locale, QChar formatChar, int precision)
void | trimTicks (const QCPRange &range, QVector< double > &ticks, bool keepOneOutlier) const
double | pickClosest (double target, const QVector< double > &candidates) const
double | getMantissa (double input, double *magnitude=nullptr) const
double | cleanMantissa (double input) const

## Additional Inherited Members
Public Types inherited from QCPAxisTicker
enum | TickStepStrategy

## Detailed Description

Specialized axis ticker suited for logarithmic axes.

This QCPAxisTicker subclass generates ticks with unequal tick intervals suited for logarithmic axis scales. The ticks are placed at powers of the specified log base (setLogBase).

Especially in the case of a log base equal to 10 (the default), it might be desirable to have tick labels in the form of powers of ten without mantissa display. To achieve this, set the number precision (QCPAxis::setNumberPrecision) to zero and the number format (QCPAxis::setNumberFormat) to scientific (exponential) display with beautifully typeset decimal powers, so a format string of `"eb"`. This will result in the following axis tick labels:

The ticker can be created and assigned to an axis like this:

QSharedPointer<QCPAxisTickerLog> logTicker(new QCPAxisTickerLog);
customPlot->xAxis->setTicker(logTicker);
// don't forget to also set the scale type accordingly, otherwise you'll have
// logarithmically spaced ticks on a linear axis:
customPlot->xAxis->setScaleType(QCPAxis::stLogarithmic);

Note that the nature of logarithmic ticks imply that there exists a smallest possible tick step, corresponding to one multiplication by the log base. If the user zooms in further than that, no new ticks would appear, leading to very sparse or even no axis ticks on the axis. To prevent this situation, this ticker falls back to regular tick generation if the axis range would be covered by too few logarithmically placed ticks.

## Constructor & Destructor Documentation

## § QCPAxisTickerLog()

QCPAxisTickerLog::QCPAxisTickerLog | ( |  | ) |

Constructs the ticker and sets reasonable default values. Axis tickers are commonly created managed by a QSharedPointer, which then can be passed to QCPAxis::setTicker.

## Member Function Documentation

## § setLogBase()

void QCPAxisTickerLog::setLogBase | ( | double | base | ) |

Sets the logarithm base used for tick coordinate generation. The ticks will be placed at integer powers of base.

## § setSubTickCount()

void QCPAxisTickerLog::setSubTickCount | ( | int | subTicks | ) |

Sets the number of sub ticks in a tick interval. Within each interval, the sub ticks are spaced linearly to provide a better visual guide, so the sub tick density increases toward the higher tick.

Note that subTicks is the number of sub ticks (not sub intervals) in one tick interval. So in the case of logarithm base 10 an intuitive sub tick spacing would be achieved with eight sub ticks (the default). This means e.g. between the ticks 10 and 100 there will be eight ticks, namely at 20, 30, 40, 50, 60, 70, 80 and 90.

## § getSubTickCount()

int QCPAxisTickerLog::getSubTickCount | ( | double | tickStep | ) |
| protectedvirtual

Returns the sub tick count specified in setSubTickCount. For QCPAxisTickerLog, there is no automatic sub tick count calculation necessary.

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPAxisTicker.

## § createTickVector()

QVector< double > QCPAxisTickerLog::createTickVector | ( | double | tickStep,
|  | const QCPRange & | range
| ) |  |
| protectedvirtual

Creates ticks with a spacing given by the logarithm base and an increasing integer power in the provided range. The step in which the power increases tick by tick is chosen in order to keep the total number of ticks as close as possible to the tick count (setTickCount).

The parameter tickStep is ignored for the normal logarithmic ticker generation. Only when zoomed in very far such that not enough logarithmically placed ticks would be visible, this function falls back to the regular QCPAxisTicker::createTickVector, which then uses tickStep.

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPAxisTicker.

The documentation for this class was generated from the following files:

- src/axis/axistickerlog.h
- src/axis/axistickerlog.cpp